/*
 * extlead.c
 *
 * Copyright (c) 2000,2001 Hajime Mochizuki <motizuki@jaist.ac.jp>
 * Natural Language Processing Laboratory,
 * Japan Advanced Institute of Science and Technology.
 * 
 * Use of this software is granted only for RESEARCH PURPOSES. 
 * Redistribution is granted as long as all copyright notices are retained.
 * Redistribution with modification is allowed provided that you make your 
 * modified version obviously distinguishable from the original one. 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES ARE DISCLAIMED.
 *
 * version: 1.00
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
static char *pname;
static int sum_mode;	/* ⡼ */
static double sum_val;  /* Ψ */
static char *fname;
static int form_mode; 	/* ɽ⡼ */
static int debug;

static help()
{
	fprintf (stderr, "extlead version 1.00 (c) Hajime Mochizuki\n");
	fprintf (stderr, "usage: %s [options] < txt_file\n", pname);
	fprintf (stderr, "\t[-sum_mode #] ϥ⡼ɻ\n");
	fprintf (stderr, "\t\t0 : ʸ-sum_valʸ\n");
	fprintf (stderr, "\t\t1 : ʸ  * -sum_valʸ default\n");
	fprintf (stderr, "\t[-sum_val #] ʸ (0.3)\n");
	fprintf (stderr, "\t[-form_mode #] ɽη\n");
	fprintf (stderr, "\t\t0 : ʸ defalut\n");
	fprintf (stderr, "\t\t1 :  ʸ\n");
	fprintf (stderr, "\t\t2 : ʸֹ ʸ\n");
	fprintf (stderr, "\t\t3 : ʸֹ \n");
	fprintf (stderr, "\t\t4 : \n");
	fprintf (stderr, "\t\t5 : ʸֹ\n");
	fprintf (stderr, "\t[-D] debug mode\n");
	fprintf (stderr, "\n");
	exit(1);
}

void optck (argc, argv)
    int   argc;
    char *argv[];
{
	pname = argv[0];
	argc--, argv++;
	sum_mode = 1;
	sum_val = (double)0.3;
	form_mode = 0;
	debug=0;
	while(argc>0 && *argv[0]=='-') {
		if (!strcmp(argv[0], "-sum_mode")) {
			argc--, argv++;
			sum_mode = atoi(argv[0]);
		} else if (!strcmp(argv[0], "-sum_val")) {
			argc--, argv++;
			sum_val = atof(argv[0]);
		} else if (!strcmp(argv[0], "-form_mode")) {
			argc--, argv++;
			form_mode = atoi(argv[0]);
		} else if (!strcmp(argv[0], "-D")) {
			debug=1;
		} else if (!strcmp(argv[0], "-h")) {
			help();
		} else {
			fprintf (stderr, "Invalid arg: %s\n", argv[0]);
			help();
		}
		argc--, argv++;
	}
}

int calc_out_snum(mode, val, snum)
    int mode;
    double val;
    int snum;
{
	int outnum;
	double diff;

	outnum = 0;
	switch (mode)
	{
	   case 0:
		outnum = (int)val;
		break;
	   case 1:
		outnum = (int)snum*val;
		diff = (snum*val) - (double)outnum;
		if (diff>=(double)0.5) {
			outnum++;
		}
		break;
	}
	if (outnum < 1) outnum = 1;

	return outnum;
}

void print_sentence (str, sn, outsn, fmode)
     char **str;
     int  sn, outsn, fmode;
{
	int i, out;

	out = outsn;
	if (out>sn) 	out = sn;
		
	for (i=0; i<out; i++) {
		switch (fmode)	{
		   case 0:
		   default:
			printf ("%s", str[i]);
			break;
		   case 1:
			printf ("0.0 %s", str[i]);
			break;
		   case 2:
			printf ("%d %s", i+1, str[i]);
			break;
		   case 3:
			printf ("%d 0.0 %s", i+1, str[i]);
			break;
		   case 4:
			printf ("0.0\n");
			break;
		   case 5:
			printf ("%d\n", i+1);
			break;
		}
	}
}

int main (argc, argv)
    int   argc;
    char *argv[];
{
	int  sn, stn, outsn;
	char **str, buf[BUFSIZ];

	optck (argc, argv);
	sn=0, stn=20;		/* sn = sentence no */
	
	if ((str=calloc((size_t)stn, sizeof(char *)))==NULL) {
		fprintf (stderr, "calloc error for str\n");
		exit(1);
	}
	while((fgets(buf, BUFSIZ, stdin))!=NULL) {
		if (sn>=stn) {
			if ((str=realloc(str, sizeof(char *)*(stn+20)))==NULL){
				fprintf (stderr, "realloc error for str\n");
				exit(1);
			}
			stn=stn+20;
		}
		str[sn]=strdup(buf);
		sn++;
	}
	outsn=0;
	outsn=calc_out_snum(sum_mode, sum_val, sn);
	if (debug) {
		fprintf (stderr, "outsn=%d\n", outsn);
	}
	print_sentence (str, sn, outsn, form_mode);
}
