/*
 * tf.c:
 * 
 * Copyright (c) 1998,2000,2001 Hajime Mochizuki <motizuki@jaist.ac.jp>
 * Natural Language Processing Laboratory,
 * Japan Advanced Institute of Science and Technology.
 * 
 * Use of this software is granted only for RESEARCH PURPOSES. 
 * Redistribution is granted as long as all copyright notices are retained.
 * Redistribution with modification is allowed provided that you make your 
 * modified version obviously distinguishable from the original one. 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES ARE DISCLAIMED.
 *
 * version: 1.00
 * (ƥȥեϤȡtf ǡˤ)
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cmn.h"
#include "chafil.h"
#include "tfflt.h"

extern CHAFLT_OUT* direct_chaflt ();
extern char*       chasen_sparse_tostr ();
static char *pname;
int outformat;

static help()
{
        fprintf (stderr, "tf version 1.00 (c) Hajime Mochizuki\n");
        fprintf (stderr, "Usage: %s [option] < txtfile\n", pname);
        fprintf (stderr, "\t[-h]    show help\n");
        fprintf (stderr, "\t[-TW]   change output format 'word tf' to 'tf word'\n");
        exit(1);
}

void optchk (argc, argv)
    int   argc;
    char *argv[];
{
        pname = argv[0];
        argc--, argv++;
        outformat=0;

        while (argc>0 && *argv[0]=='-') {
                if (!strcmp(argv[0], "-h")) {
                        help();
                } else if (!strcmp(argv[0], "-TW")) {
                        outformat=1;
                } else {
                        fprintf (stderr, "Invalid arg: %s\n", argv[0]);
                        help();
                }
                argc--, argv++;
        }
}

int main (argc, argv)
    int    argc;
    char *argv[];
{
	int i, sn, sw, id, entry;
	char record[BUFSIZ], *cptr;
        CHAFLT_OUT *words;
        struct hash_entry *hashtab[5000];
        int    hashsize;

        hashsize=5000;
        optchk(argc, argv);
        chasen_preparation (pname);
        sn = id = 1;
        entry = 0;
        init_hash_f (hashtab, hashsize);
	while (fgets(record, BUFSIZ, stdin)!=NULL) {
		cptr =  chasen_sparse_tostr (record);
		words = direct_chaflt (cptr, sn,0);
		entry+= tffilter (words, hashtab, hashsize);
		chaflt_out_init();
	}
	init_hash (hashtab, hashsize, 0, outformat);
}
