/*
 * cfidfsw.c: 
 *
 * Copyright (c) 1998-2001 Hajime Mochizuki <motizuki@jaist.ac.jp>
 * Natural Language Processing Laboratory,
 * Japan Advanced Institute of Science and Technology.
 * 
 * Use of this software is granted only for RESEARCH PURPOSES. 
 * Redistribution is granted as long as all copyright notices are retained.
 * Redistribution with modification is allowed provided that you make your 
 * modified version obviously distinguishable from the original one. 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES ARE DISCLAIMED.
 *
 * version: 1.02
 *
 *  ʸγƸνŤߤ cf or cfidfǷ׻­礻롥
 *  query biased ˤб
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "cmn.h"
#include "nero.h"
#include "cfidfsw.h"
#include "chafil.h"
#include "tfflt.h"
#include "qbnrm.h"


extern struct patrash_files* patrash_preparation ();
extern struct patrash_answer_int* tell_patrash_int ();
extern int         chaflt_out_num;
extern int         number_of_words;
extern CHAFLT_OUT* direct_chaflt ();
extern char*       chasen_sparse_tostr ();

extern void sscalcmore();
extern int get_tf_from_hash();


static char *pname;
static int  chnw_mode;	/* ϢνŤդ⡼ 0:no 1:cf 2:cfidf*/
static char *dffile;	/* dffile ̾ */
static char *qffile;	/* query file ̾ */
static int  min_chntf;	/* ʾϢǧ뤫 */
static int  thre_mode;	/* Ϣˤ­ڤ⡼ */
static double thre_val;	/* ­ڤ */
static double ppw[8];	/* pp or pos Υ */
static length_mode;     /* chain,gap length thresholdƳ뤫 */
int    chain_bunbo;
int    gap_bunbo;
int    num_of_words;
int    num_of_sents;
int    chain_threshold;
int    gap_threshold;
int    N;
static int qb;
double qwgt;
static int use_cha; /* query biasedˤqfileβchasenȤ⡼ */

static int  norm_mode;	/* ʸĹˤ⡼ */
static double norm_val;	/* Ψ? */

#ifndef HashSize
#define HashSize 1001
#endif

static help()
{
    fprintf (stderr, "cfidfsw version 1.02 (c) Hajime Mochizuki\n");
    fprintf (stderr, "usage: %s [options] < chain_file\n", pname);
    fprintf (stderr, "\n");
    fprintf (stderr, "\t[-cwm #] ŪϢνŤդ⡼ɻ\n");
    fprintf (stderr, "\t\t0   : Ťդʤ\n");
    fprintf (stderr, "\t\t1   : Ťդ cf (default)\n");
    fprintf (stderr, "\t\t2   : Ťդ cfidf (dffileɬ)\n");
    fprintf (stderr, "\t[-df #] ŤդΤdffile\n");
    fprintf (stderr, "\t[-qf #] query biasedΤ Queryfile\n");
    fprintf (stderr, "\t[-qwgt #] query biasedΤ Ťߤ(3)\n");
    fprintf (stderr, "\t[-nm #] ʸĹˤ⡼ɻ\n");
    fprintf (stderr, "\t\t0 : ʤ (default)\n");
    fprintf (stderr, "\t\t1 : ñ\n");
    fprintf (stderr, "\t\t2 : ʸкͤ\n");
    fprintf (stderr, "\t\t3 : ʸΥ2/ñ\n");
    fprintf (stderr, "\t\t4 : ñ*-nm_val \n");
    fprintf (stderr, "\t\t5 : (ñǳ/2)+(ʸкͤǳ)\n");
    fprintf (stderr, "\t[-nm_val #] -nm 4λνŤ (1)\n");
    fprintf (stderr, "\t[-h]  help\n");
    fprintf (stderr, "\t[-hh] help2\n");
}
/*
 * use_cha4qb ˤĤƤϡüʻˡΤʤ
 */
static help2()
{
    fprintf (stderr, "\n");
    fprintf (stderr, "\t[-min_chntf #] ʾϢǧ뤫 (1)\n");
    fprintf (stderr, "\t[-thre_mode #] Ϣˤ­ڤ⡼ɻ\n");
    fprintf (stderr, "\t\t0 : ­ڤꤷʤ (default)\n");
    fprintf (stderr, "\t\t1 : Ϣʿ* -thre_val ʾ\n");
    fprintf (stderr, "\t\t2 : -thre_valʾ\n");
    fprintf (stderr, "\t[-thre_val #] -thre_mode 0ʳλνŤ߻(0.5)\n");
    fprintf (stderr, "\t[-wg #]               (1.4)\n");
    fprintf (stderr, "\t[-ww #]               (1.2)\n");
    fprintf (stderr, "\t[-wk #] ¾γʽ  (1.0)\n");
    fprintf (stderr, "\t[-wh #]               (1.4)\n");
    fprintf (stderr, "\t[-wm #]               (1.2)\n");
    fprintf (stderr, "\t[-wf #] ¾  (1.0)\n");
    fprintf (stderr, "\t[-wn #] ʤ            (1.0)\n");
    fprintf (stderr, "\t[-wy #] Ѹ            (0.8)\n");
    fprintf (stderr, "\t[-chain #] chain length thresholdʬ\n");
    fprintf (stderr, "\t[-gap #] gap lengh thresholdʬ\n");
    fprintf (stderr, "\n");
}

void optchk (argc, argv)
       int   argc;
       char *argv[];
{
	pname = argv[0];
	qwgt=(double)3;
	qb = 0;
	chnw_mode = 1;
	min_chntf = 1;
	thre_mode = 0;
	thre_val  = (double)0.5;
	length_mode = 0;
	use_cha=0;

	ppw[GA] = (double)1.4;         /*  */
	ppw[WO] = (double)1.2;         /*  */
	ppw[KA] = (double)1.0;         /* ¾γʽ */
	ppw[HA] = (double)1.4;         /*  */
	ppw[MO] = (double)1.2;         /*  */
	ppw[FU] = (double)1.0;         /* ¾ */
	ppw[NO] = (double)1.0;         /* ʤ */
	ppw[YO] = (double)0.8;         /* Ѹ */

	chain_bunbo=100;
	gap_bunbo = 10;
	chain_threshold = 1;
	gap_threshold = 1;

/*	if (argc<) {
		help();
	}
*/
	argc--, argv++;

	while (argc>0 && *argv[0]=='-') {
		if (!strcmp(argv[0], "-df")) {
			argc--, argv++;
			dffile = argv[0];
/*			chnw_mode = 2;*/
		} else if (!strcmp(argv[0], "-cwm")) {
			argc--, argv++;
			chnw_mode = atoi(argv[0]);
		} else if (!strcmp(argv[0], "-qf")) {
			argc--, argv++;
			qb=1;
			qffile = argv[0];
		} else if (!strcmp(argv[0], "-use_cha4qb")) {
			use_cha=1;
		} else if (!strcmp(argv[0], "-qwgt")) {
			argc--, argv++;
			qwgt = atof(argv[0]);
		} else if (!strcmp(argv[0], "-min_chntf")) {
			argc--, argv++;
			min_chntf = atoi(argv[0]);
		} else if (!strcmp(argv[0], "-thre_mode")) {
			argc--, argv++;
			thre_mode = atoi(argv[0]);
		} else if (!strcmp(argv[0], "-thre_val")) {
			argc--, argv++;
			thre_val = atof(argv[0]);
		} else if (!strcmp(argv[0], "-nm")) {
			argc--, argv++;
			norm_mode=atoi(argv[0]);
		} else if (!strcmp(argv[0], "-nm_val")) {
			argc--, argv++;
			norm_val = atof(argv[0]);
		} else if (!strcmp(argv[0], "-wg")) {
			argc--, argv++;
			ppw[GA] = atoi(argv[0]);
		} else if (!strcmp(argv[0], "-ww")) {
			argc--, argv++;
			ppw[WO] = atoi(argv[0]);
		} else if (!strcmp(argv[0], "-wk")) {
			argc--, argv++;
			ppw[KA] = atoi(argv[0]);
		} else if (!strcmp(argv[0], "-wh")) {
			argc--, argv++;
			ppw[HA] = atoi(argv[0]);
		} else if (!strcmp(argv[0], "-wm")) {
			argc--, argv++;
			ppw[MO] = atoi(argv[0]);
		} else if (!strcmp(argv[0], "-wf")) {
			argc--, argv++;
			ppw[FU] = atoi(argv[0]);
		} else if (!strcmp(argv[0], "-wn")) {
			argc--, argv++;
			ppw[NO] = atoi(argv[0]);
		} else if (!strcmp(argv[0], "-wy")) {
			argc--, argv++;
			ppw[YO] = atoi(argv[0]);
		} else if (!strcmp(argv[0], "-chain")) {
			argc--, argv++;
			chain_bunbo = atoi(argv[0]);
		} else if (!strcmp(argv[0], "-gap")) {
			argc--, argv++;
			gap_bunbo = atoi(argv[0]);
		} else if (!strcmp(argv[0], "-h")) {
			help();
			exit(1);
		} else if (!strcmp(argv[0], "-hh")) {
			help();
			help2();
			exit(1);
		} else {
			fprintf (stderr, "Invalid arg: %s\n", argv[0]);
			help();
			exit(1);
		}
		argc--, argv++;
	}
}


double calc_cscr (tf, snw, cdat, cn, N, df, qper)
    int tf;
    struct snword *snw;
    struct chain_data *cdat;
    int cn, N, df;
    double qper;
{
	int i;
	double scr;
	struct snword *tsnw;
	
	if (chnw_mode==0) {
		scr = (double)1*qper;
	} else if (chnw_mode==1) {
		scr = (double)tf*qper;
	} else if (chnw_mode==2) {
		scr = (double)tf * log((double)N/(double)df) *qper;
	} else if (chnw_mode==3){
		scr = qper *(double)tf * log((double)N/(double)df);
	}
	if ((tsnw=calloc((size_t)tf, sizeof(struct snword)))==NULL) {
		perror ("calloc for snw");
		exit(1);
	}
	for (i=0; i<tf; i++) {
		tsnw[i].sn   = snw[i].sn;
		tsnw[i].word = strdup(snw[i].word);
		strcpy(tsnw[i].pp, snw[i].pp);
	}

	cdat[cn].cwn = tf;
	cdat[cn].score = scr;
	cdat[cn].snw = tsnw;

	return scr;
}

void calc_sscr (cdat, cn, ss, acscr)
    struct chain_data *cdat;
    int cn;
    struct sentence *ss;
    double acscr;

{
	int i, j, ppi;
	double ave, thre;

	ave = acscr / (double)cn;

	if (thre_mode==0) {
		thre = (double)0;
	} else if (thre_mode==1) {
		thre = ave*thre_val;
		fprintf (stderr, "acscr =%f cn = %d ave = %f thre = %f\n", acscr, cn, ave, thre); 
	} else {
		thre = thre_val;
	}
	for (i=0; i<cn; i++) {
		if (cdat[i].score>=thre) {	/* Ͱʾ */
			for (j=0; j<cdat[i].cwn; j++) {
				if(!strcmp(cdat[i].snw[j].pp, "gashugo")) {
					ppi=GA;
				} else if (!strcmp(cdat[i].snw[j].pp,
						   "wotsuki")) {
					ppi=WO;
				} else if (!strcmp(cdat[i].snw[j].pp,
						   "kakujoshi")) {
					ppi=KA;
				} else if (!strcmp(cdat[i].snw[j].pp,
						   "hashugo")) {
					ppi=HA;
				} else if (!strcmp(cdat[i].snw[j].pp,
						   "motsuki")) {
					ppi=MO;
				} else if (!strcmp(cdat[i].snw[j].pp,
						   "fukujoshi")) {
					ppi=FU;
				} else if (!strcmp(cdat[i].snw[j].pp,
						   "no")) {
					ppi=NO;
				} else if (!strcmp(cdat[i].snw[j].pp,
						   "yougen")) {
					ppi=YO;
				} 
				ss[cdat[i].snw[j].sn].scr+= cdat[i].score * ppw[ppi];
			}
		}
	}
}

int main (argc, argv)
    int   argc;
    char *argv[];
{
	int i, sn, wn, tf, df, wc, lex, cn, N, cdct, qhashsize=HashSize;
	int j, qentry, sct, awwct;
	char buf[BUFSIZ], word[6][50], QWD[100], QTF[20];
	/*double *ss, acscr, qper;*/
	double acscr, qper;
	struct sentence *ss, *tp;
	char *cptr;
	struct tmpwords *tw, *tmp;
	CHAFLT_OUT *words;
	struct snword *snw;
	struct chain_data *cdat, *ctmp;
	struct hash_entry *qhashtab[HashSize];
	struct patrash_files *pf;
	struct patrash_answer_int *intr;
	FILE *qfile;

	optchk(argc, argv);

	fgets(buf, BUFSIZ, stdin); /* ñ ʸ ɤ߹ */
	buf[strlen(buf)-1]='\0';
	for (i=0; buf[0]!='\0'; i++) {
		word[i][0] = '\0';
		splitdata (word[i], buf, ' ');
	}
	sn = atoi(word[1]);
	wn = atoi(word[0]);

	/* for sentence score */
	/*
        if ((ss=calloc((size_t)(sn+1), sizeof(double)))==NULL) {
                perror ("calloc for ss");
                exit(1);
        }
	*/
	if ((ss=calloc((size_t)31, sizeof(*ss)))==NULL) {
		perror("calloc for ss");
		exit(1);
	}
	sct=31, j=1;
	for(i=0; i<sct; i++) {
		ss[i].scr=(double)0;
		ss[i].wnum=0;
	}
	/* for sentence no - word data */
        if ((snw=calloc((size_t)(wn+10), sizeof(*snw)))==NULL) {
                perror ("calloc for snw");
                exit(1);
        }
	if ((cdat=calloc((size_t)30, sizeof(*cdat)))==NULL) {
		perror ("calloc for cdat");
		exit(1);
	}
	cdct=30;
	cn=0, N=0, tf=0, df=1, acscr=(double)0;
	if (chnw_mode==2) {
		if (dffile==NULL) help();
		pf = patrash_preparation (dffile);
		intr  = tell_patrash_int ("N", pf->pa, pf->wan);
		if (intr==NULL) {
			fprintf (stderr, "??? dffile is broken??\n");
			exit(1);
		}
		N = intr->num;
		free(intr); intr=NULL;
	}

	if (qb==1) {
		if (qffile==NULL) help();
		if ((qfile=fopen(qffile, "r"))==NULL) {
			fprintf (stderr, "cannot open %s\n", qffile);
			exit(1);
		}
		init_hash_f (qhashtab, qhashsize); 
		qentry = 0;
		if (use_cha==1) {  /* -use_cha4qb */
			chasen_preparation (pname);
			while (fgets(buf, BUFSIZ, qfile)!=NULL) {
				cptr = chasen_sparse_tostr (buf);
				words = direct_chaflt (cptr, 0);
				qentry+=tffilter (words, qhashtab, qhashsize);
				chaflt_out_init();
			}
		} else {
			while (fgets(buf, BUFSIZ, qfile)!=NULL) {
				sscanf(buf, "%s %s\n", QWD, QTF);
				qentry+=hash_update(QWD, QTF, qhashtab, qhashsize);
			}
		}
		fclose(qfile);
	}

	while (fgets(buf, BUFSIZ, stdin)!=NULL) {
		if (buf[0]=='\n') {
			if (chnw_mode==2 && lex==1) {
				intr = tell_patrash_int 
				     (snw[0].sense, pf->pa, pf->wan);
				if (intr!=NULL) {
					df = intr->num;
					free(intr); intr=NULL;
				}
			}
			if (tf >= min_chntf)  {
				if (cn>=cdct) {
					if ((ctmp=
					     realloc(cdat,
						     sizeof(*cdat)*(cdct+10)))
					    ==NULL) {
						perror ("malloc for cdat");
						exit(1);
					}
					cdat=ctmp, cdct+=10;
				}
				acscr+=calc_cscr (tf, snw, cdat, cn, N, df, qper);
				cn++;
			}
			tf=0, df=1, qper=(double)1;
		} else {
			buf[strlen(buf)-1]='\0';
			for (i=0; buf[0]!='\0'; i++) {
				word[i][0]='\0';
				splitdata (word[i], buf, ' ');
			}
			snw[tf].sn=atoi(word[0]);
			if (snw[tf].sn>=sct) {
				if ((tp=realloc(ss, sizeof(*ss)*(sct+10)))==NULL) {
					perror ("malloc for ss");
					exit(1);
				}
				for(i=sct; i<sct+10; i++) {
					ss[i].scr=(double)0;
					ss[i].wnum=0;
				}
				ss=tp;
				sct+=10;
			}
			ss[snw[tf].sn].sn = snw[tf].sn;
			ss[snw[tf].sn].wnum++;
			awwct+= ss[snw[tf].sn].wnum;

			if (cn==0 && tf==0) {
				if (i==4) {
					lex = 0;
				} else {
					lex = 1;
				}
			}
			if (lex==0) { /* ١Ϣ */
				snw[tf].word = strdup (word[3]);
				snw[tf].sense= strdup (word[3]);
				strcpy(snw[tf].pp, word[4]);
			} else {    /* 饹١Ϣ */
				snw[tf].word = strdup (word[3]);
				snw[tf].sense= strdup (word[4]);
				strcpy(snw[tf].pp, word[5]);
			}
			if (qb==1)
				if(chk_word_in_hash(snw[tf].word,
						    qhashtab, qhashsize)) {
					qper=qwgt;
				}
			switch (chnw_mode) {
			   case 2:
				if (lex==0) {
					intr=tell_patrash_int 
					     (word[3], pf->pa, pf->wan);
					if (intr!=NULL) {
						if (df < intr->num) {
							df = intr->num;
						}
						free(intr); intr=NULL;
					}
				}
				break;
			}
			tf++;
		}
	}
	calc_sscr (cdat, cn, ss, acscr);
	sscalcmore(ss, sn, awwct, norm_mode, norm_val);
	/*
	for (i=1; i<=sn; i++) {
		printf ("%d %f\n", i, ss[i].scr);
	}
	*/
}

