/*
 * getnorm.c:
 *
 * Copyright (c) 1998,2001 Hajime Mochizuki <motizuki@jaist.ac.jp>
 * Natural Language Processing Laboratory,
 * Japan Advanced Institute of Science and Technology.
 * 
 * Use of this software is granted only for RESEARCH PURPOSES. 
 * Redistribution is granted as long as all copyright notices are retained.
 * Redistribution with modification is allowed provided that you make your 
 * modified version obviously distinguishable from the original one. 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES ARE DISCLAIMED.
 *
 *  ɥĹˤͤ׻
 * 
 *     arg1 df_patname   (gettfdfdffilepatrash_intpatƤ)
 *     arg2 tffile
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "nero.h"

extern struct patrash_answer_int* tell_patrash_int();

double calc_a (word, tf, pa, pwan, N)
     char *word;
     int  tf;
     struct patrash_array *pa;
     FILE *pwan;
     int  N;
{
	int df;
	double tmp, tmp2;
	struct patrash_answer_int *intr;

	intr = tell_patrash_int (word, pa, pwan);
	tmp = log((double)N/(double)intr->num);
	tmp = tmp*tmp;
	tmp2= (double)tf*(double)tf;
	tmp = tmp*tmp2;
	free(intr);
	return tmp;
}


int get_N (pa, pwan)
    struct patrash_array *pa;
    FILE *pwan;
{
	int N;
	struct patrash_answer_int *intr;

	intr = tell_patrash_int ("N", pa, pwan);
	N = intr->num;
	free(intr);
	return N;
}

int main (argc, argv)
    int   argc;
    char *argv[];
{
	char pat[200], tffn[200], buf[BUFSIZ], word[200];
	int  tf, id, N;
	FILE *pwan, *pidx, *tff;
	struct patrash_array *pa;
	double tmp;

	extern FILE* open_patrash_idx();
	extern FILE* open_patrash_wan();
	extern struct patrash_array*   read_patrash_idx();
	
	
	if (argc<3) {
		fprintf (stderr, "%s df_patname tffilename\n", argv[0]);
		exit(1);
	}

	strcpy(pat,  argv[1]);
	strcpy(tffn, argv[2]);

	pidx = open_patrash_idx (pat);
	pwan = open_patrash_wan (pat);
	pa   = read_patrash_idx (pidx);
	fclose(pidx);
	
	if((tff = fopen(tffn, "r"))==NULL) {
		perror ("cannot open");
		exit(1);
	}
	tmp = (double)0;
	
	N = get_N (pa, pwan);
	id = 1;
	while(fgets(buf, BUFSIZ, tff)!=NULL) {
		sscanf (buf, "%s %d\n", word, &tf);
		if (strcmp(word, "EOF")==0) {
			tmp = sqrt(tmp);
			printf ("%d %f\n", id, tmp);
			tmp = (double)0;
			id++;
		} else {
			tmp += calc_a (word, tf, pa, pwan, N);
		}
	}
	fclose(tff);
}
