/*
 * keyweight.c: 
 *
 * Copyright (c) 1998,2001 Hajime Mochizuki <motizuki@jaist.ac.jp>
 * Natural Language Processing Laboratory,
 * Japan Advanced Institute of Science and Technology.
 * 
 * Use of this software is granted only for RESEARCH PURPOSES. 
 * Redistribution is granted as long as all copyright notices are retained.
 * Redistribution with modification is allowed provided that you make your 
 * modified version obviously distinguishable from the original one. 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES ARE DISCLAIMED.
 *
 * keywordtfidf׻
 *
 *     arg 1 df_patfile
 *     arg 2 tffile
 *     arg 3 [norm_patfile] <- getnormǷ׻pat
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "nero.h"

extern struct patrash_answer_int* tell_patrash_int();
extern struct patrash_answer_double* tell_patrash_double();
extern FILE* open_patrash_idx();
extern FILE* open_patrash_wan();
extern struct patrash_array*   read_patrash_idx();

int get_N (pa, pwan)
    struct patrash_array *pa;
    FILE *pwan;
{
	int N;
	struct patrash_answer_int *intr;

	intr = tell_patrash_int ("N", pa, pwan);
	N = intr->num;
	free(intr);
	return N;
}

double tfidf(word, tf, N, pa, dfwan, nmsw, mode, nm_val, pi, nmwan)
     char *word;
     int tf, N;
     struct patrash_array *pa;
     FILE *dfwan;
     int nmsw;
     double nm_val;
     struct patrash_array *pi;
     FILE *nmwan;
{
	double w;
	struct patrash_answer_int *intr;

	intr = tell_patrash_int (word, pa, dfwan);
	
	switch (mode) {
	    case 1:
		w = (double)tf * log((double)N/(double)intr->num);
		break;
	    default:
		w = (double)tf * log((double)N/(double)intr->num);
		break;
	}

	if (nmsw==1) {
		w = w/nm_val;
	}
	free (intr);
	return w;
}

double get_norm (id, pi, nmwan)
     int id;
     struct patrash_array *pi;
     FILE *nmwan;
{
	char ids[20];
	double d;
	struct patrash_answer_double *dblr;

	sprintf (ids, "%d", id);
	dblr = tell_patrash_double (ids, pi, nmwan);
	d = dblr->dbl;
	free(dblr);
	return d;
}


int main (argc, argv)
    int   argc;
    char *argv[];
{
	int nmsw, id, N, tf;
	double scr, nm_val;
	char tfn[200], dfn[200], nmn[200], buf[BUFSIZ], word[200];
	struct patrash_array *pa, *pi;
	FILE *dfwan, *dfidx, *nmwan, *nmidx, *tff;

	if (argc<3) {
		fprintf (stderr, "%s df_patfile tffilename [norm_patfile]\n",
			 argv[0]);
		exit(1);
	}
	strcpy(dfn, argv[1]);
	strcpy(tfn, argv[2]);
	if (argc==4) {
		strcpy(nmn, argv[3]);
		nmsw=1;
	} else {
		nmsw=0;
	}
	if ((tff=fopen(tfn, "r"))==NULL) {
		fprintf(stderr, "cannot open %s\n", tfn);
		exit(1);
	}
	dfidx = open_patrash_idx (dfn);
	dfwan = open_patrash_wan (dfn);
	pa   = read_patrash_idx (dfidx);
	fclose(dfidx);

	if (nmsw==1) {
		nmidx = open_patrash_idx (nmn);
		nmwan = open_patrash_wan (nmn);
		pi   = read_patrash_idx (nmidx);
		fclose(nmidx);
	}

	N = get_N (pa, dfwan);
	id=1;
	nm_val = (double)1;
	if (nmsw==1) {
		nm_val = get_norm (id, pi, nmwan);
	}
	while ((fgets(buf, BUFSIZ, tff))!=NULL) {
		sscanf(buf, "%s %d\n", word, &tf);
		if (strcmp(word, "EOF")==0) {
			id++;
			if (nmsw==1 && id<=N) {
				nm_val = get_norm (id, pi, nmwan);
			}
		} else {
			if (nmsw==0) {
				scr = tfidf(word, tf, N, pa, dfwan, nmsw, 1);
			} else {
				scr = tfidf(word, tf, N, pa, dfwan, nmsw, 1, nm_val, pi, nmwan);
			}
			printf ("%s %d %f\n", word, id, scr);
		}
	}
}
